package Ejer05_05_07;

import java.util.concurrent.CyclicBarrier;

public class Downloader2 {
	
	private static final int N_FRAGMENTOS = 3;
	private static final int N_HILOS = 3;
	private static final int N_FICHEROS = 3;
	
	private static volatile int[] fichero = new int[N_FRAGMENTOS];
	
	private static Object nextFragmentLock = new Object();
	private static int nextFragment = 0;
	
	private static CyclicBarrier barrera;

	private static int descargaDatos(int numFragmento){
		
		try {
			Thread.sleep((long) (Math.random()*1000));
		}catch (InterruptedException e){	
		}
		return numFragmento * 2;	
	}
	
	private static void mostrarFichero() {
		
		System.out.println("--------------------------------------------------");
		System.out.print("File = [");
		for (int i = 0; i < N_FRAGMENTOS; i++) {
			
			System.out.print(fichero[i] + ",");
		
		}
		System.out.println("]");	
	}
	
	public static void descargafichero() {
		
		do{
			int localFragmento = 0;
			
			synchronized (nextFragmentLock) {
				if (nextFragment < N_FRAGMENTOS) {
					localFragmento = nextFragment;
					nextFragment++;
				}else {
					break;
				}
			}
			String threadname = Thread.currentThread().getName();
			System.out.println(threadname+ ": Descargando fragmento " +localFragmento);
				
			int datodescargado = descargaDatos(localFragmento);
				
			System.out.println(threadname+ ": Escribiendo fragmento " +localFragmento);
			fichero[localFragmento] = datodescargado;

			} while(true);
	}
	
	public static void downloader(){
		
		for(int i =0; i < N_FICHEROS; i++) {
			descargafichero();
			try {
				System.out.println(Thread.currentThread().getName()+ " esperando el siguiente fichero");
				barrera.await();
			}catch (Exception e){
				e.printStackTrace();
			}
		}
	}
	
	private void fileRefresh() {
		mostrarFichero();
		nextFragment =0;
		fichero = new int[N_FRAGMENTOS];
	}
	
	public void exec() {
		
		barrera = new CyclicBarrier(N_HILOS, ()->fileRefresh());
		
		for(int i=0;i<N_HILOS;i++) {
			new Thread(()->downloader(),"Downloader"+i).start();
		}
	}
	
	public static void main(String[] args) throws InterruptedException  {
		new Downloader2().exec();
	}
}