
public class Scalextric {

	private static final int M = 10; // Numero de coches
	private static final int N = 3; // Numero de piezas del circuito	
	private static Pieza[] circuito = new Pieza[N];

	public static void coche(int numeroCoche) {
		try {
			for (int i=0; i<N; i++) circuito[i].recorrerPieza(numeroCoche);
		} catch (InterruptedException e) {
			System.out.println(e.getCause());
		}
	}

	public static void main(String[] args) {
		
		// Creamos el circuito
		circuito[0] = new Pieza(0,false,M); // Primera pieza
		System.out.print("Pistas de cada pieza del circuito: " + M);
		for (int i=1; i<N; i++) {
			circuito[i] = new Pieza(i,true,M);
			System.out.print(", " + circuito[i].getPistas());
		}
		System.out.println();
		circuito[N-1].setUltimaPieza(); // Marcamos la ltima pieza como meta
		
		// Arrancamos los coches
		for (int i=0; i<M; i++) {
			int nCoche=i;
			new Thread(()->coche(nCoche)).start();
		}
	}

} // Fin clase Scalextric
